// This file defines Macros and Attributes defined in CLI header files
// It is exported by odbc.js so that all get available for application
// Application can use it as ibmdb.SQL_ATTR_PARAMSET_SIZE instead of 22

module.exports.attributes = {
    // Connection Attributes
    SQL_ATTR_ACCESS_MODE : 101,
    SQL_ATTR_AUTOCOMMIT : 102,
    SQL_ATTR_LOGIN_TIMEOUT : 103,
    SQL_ATTR_TRACE : 104,
    SQL_ATTR_TRACEFILE : 105,
    SQL_ATTR_TRANSLATE_LIB : 106,
    SQL_ATTR_TRANSLATE_OPTION : 107,
    SQL_ATTR_TXN_ISOLATION : 108,
    SQL_ATTR_CURRENT_CATALOG : 109,
    SQL_ATTR_ODBC_CURSORS : 110,
    SQL_ATTR_QUIET_MODE : 111,
    SQL_ATTR_PACKET_SIZE :112,
    SQL_ATTR_CONNECTION_TIMEOUT : 113,
    SQL_ATTR_DISCONNECT_BEHAVIOR : 114,
    SQL_ATTR_ANSI_APP : 115,
    SQL_ATTR_RESET_CONNECTION : 116,
    SQL_ATTR_ASYNC_DBC_FUNCTIONS_ENABLE : 117,
    SQL_ATTR_INFO_USERID : 1281,
    SQL_ATTR_INFO_WRKSTNNAME : 1282,
    SQL_ATTR_INFO_APPLNAME : 1283,
    SQL_ATTR_INFO_ACCTSTR : 1284,
    SQL_ATTR_ALLOW_INTERLEAVED_GETDATA : 2599,

    // Statement Attributes
    SQL_ATTR_QUERY_TIMEOUT : 0,
    SQL_ATTR_ASYNC_ENABLE : 4,
    SQL_ATTR_PARAM_BIND_TYPE : 18,
    SQL_ATTR_PARAMSET_SIZE : 22,
    SQL_ATTR_ROW_ARRAY_SIZE : 27,

    // InfoType for SQLGetInfo i.e. ibmdb.getInfo()
    // Defined in sqlcli1.h
    SQL_DATA_SOURCE_NAME : 2,
    SQL_FETCH_DIRECTION : 8,
    SQL_SERVER_NAME : 13,
    SQL_SEARCH_PATTERN_ESCAPE : 14,
    SQL_ODBC_SQL_CONFORMANCE : 15,
    SQL_DATABASE_NAME : 16,
    SQL_DBMS_NAME : 17,
    SQL_DBMS_VER : 18,
    SQL_ACCESSIBLE_TABLES : 19,
    SQL_ACCESSIBLE_PROCEDURES : 20,
    SQL_PROCEDURES : 21,
    SQL_CONCAT_NULL_BEHAVIOR : 22,
    SQL_CURSOR_COMMIT_BEHAVIOR : 23,
    SQL_CURSOR_ROLLBACK_BEHAVIOR : 24,
    SQL_DATA_SOURCE_READ_ONLY : 25,
    SQL_DEFAULT_TXN_ISOLATION : 26,
    SQL_EXPRESSIONS_IN_ORDERBY : 27,
    SQL_IDENTIFIER_CASE : 28,
    SQL_IDENTIFIER_QUOTE_CHAR : 29,
    SQL_MAX_COLUMN_NAME_LEN : 30,
    SQL_MAX_CURSOR_NAME_LEN : 31,
    SQL_MAX_SCHEMA_NAME_LEN : 32,
    SQL_MAX_PROCEDURE_NAME_LEN : 33,
    SQL_MAX_TABLE_NAME_LEN : 35,
    SQL_MULT_RESULT_SETS : 36,
    SQL_MULTIPLE_ACTIVE_TXN : 37,
    SQL_OUTER_JOINS : 38,
    SQL_PROCEDURE_TERM : 40,
    SQL_TXN_CAPABLE : 46,
    SQL_USER_NAME : 47,
    SQL_MAX_COLUMNS_IN_SELECT : 100,
    SQL_MAX_COLUMNS_IN_TABLE : 101,
    SQL_MAX_INDEX_SIZE : 102,
    SQL_MAX_ROW_SIZE : 104,
    SQL_MAX_STATEMENT_LEN : 105,
    SQL_DBMS_FUNCTIONLVL : 203,
    SQL_DATABASE_CODEPAGE : 2519,
    SQL_APPLICATION_CODEPAGE : 2520,
    SQL_CONNECT_CODEPAGE : 2521,
    SQL_DB2_DRIVER_VER : 2550,
    SQL_DRIVER_BLDLEVEL : 2604,
    SQL_XOPEN_CLI_YEAR : 10000,
    // sqlext.h
    SQL_DRIVER_NAME : 6,
    SQL_DRIVER_VER :7,
    SQL_ODBC_API_CONFORMANCE : 9,
    SQL_ODBC_VER : 10,
    SQL_ROW_UPDATES : 11,
    SQL_ODBC_SAG_CLI_CONFORMANCE : 12,
    SQL_DATABASE_NAME : 16,
    // fetchMode
    FETCH_ARRAY : 3,
    FETCH_OBJECT : 4,
    FETCH_NODATA : 0,

    // InfoType for SQLGetTypeInfo i.e. ibmdb.getTypeInfo()
    // Defined in sqlcli1.h and sqlext.h
    ALLTYPES : 0, //SQL_ALL_TYPES
    BIGINT : -5, //SQL_BIGINT
    BINARY : -2,
    BIT : -7,
    BLOB : -98,
    BOOLEAN : 16,
    CHAR : 1,
    CLOB : -99,
    DATE : 91, //SQL_TYPE_DATE
    DBCLOB : -350,
    DECIMAL : 3,
    DOUBLE : 8,
    FLOAT : 6,
    GRAPHIC : -95,
    INTEGER : 4,
    LONGVARBINARY : -4,
    LONGVARCHAR : -1,
    LONGVARGRAPHIC : -97,
    NUMERIC : 2,
    REAL : 7,
    SMALLINT : 5,
    TIME : 92, //SQL_TYPE_TIME
    TIMESTAMP : 93, //SQL_TYPE_TIMESTAMP
    TINYINT : -6,
    VARBINARY : -3,
    VARCHAR : 12,
    VARGRAPHIC : -96,
    XML : -370,

    // Function Id for SQLGetFunctions i.e. ibmdb.getFunctions()
    // Defined in sqlcli1.h and sqlext.h
    ALLFUNCTIONS      : 0, //SQL_API_ALL_FUNCTIONS
    SQLALLOCCONNECT   : 1, //SQL_API_SQLALLOCCONNECT
    SQLALLOCENV       : 2, //SQL_API_SQLALLOCENV
    SQLALLOCSTMT      : 3, //SQL_API_SQLALLOCSTMT
    SQLBINDCOL        : 4, //SQL_API_SQLBINDCOL
    SQLCANCEL         : 5, //SQL_API_SQLCANCEL
    SQLCOLATTRIBUTE   : 6, //SQL_API_SQLCOLATTRIBUTE
    SQLCOLATTRIBUTES  : 6, //SQL_API_SQLCOLATTRIBUTES
    SQLCONNECT        : 7, //SQL_API_SQLCONNECT
    SQLDESCRIBECOL    : 8, //SQL_API_SQLDESCRIBECOL
    SQLDISCONNECT     : 9, //SQL_API_SQLDISCONNECT
    SQLERROR          : 10, //SQL_API_SQLERROR
    SQLEXECDIRECT     : 11, //SQL_API_SQLEXECDIRECT
    SQLEXECUTE        : 12, //SQL_API_SQLEXECUTE
    SQLFETCH          : 13, //SQL_API_SQLFETCH
    SQLFREECONNECT    : 14, //SQL_API_SQLFREECONNECT
    SQLFREEENV        : 15, //SQL_API_SQLFREEENV
    SQLFREESTMT       : 16, //SQL_API_SQLFREESTMT
    SQLGETCURSORNAME  : 17, //SQL_API_SQLGETCURSORNAME
    SQLNUMRESULTCOLS  : 18, //SQL_API_SQLNUMRESULTCOLS
    SQLPREPARE        : 19, //SQL_API_SQLPREPARE
    SQLROWCOUNT       : 20, //SQL_API_SQLROWCOUNT
    SQLSETCURSORNAME  : 21, //SQL_API_SQLSETCURSORNAME
    SQLSETPARAM       : 22, //SQL_API_SQLSETPARAM
    SQLTRANSACT       : 23, //SQL_API_SQLTRANSACT
    SQLBULKOPERATIONS : 24, //SQL_API_SQLBULKOPERATIONS
    SQLCOLUMNS        : 40, //SQL_API_SQLCOLUMNS
    SQLDRIVERCONNECT  : 41, //SQL_API_SQLDRIVERCONNECT
    SQLGETCONNECTOPTION : 42,
    SQLGETDATA          : 43,
    SQLGETFUNCTIONS     : 44,
    SQLGETINFO          : 45,
    SQLGETSTMTOPTION    : 46,
    SQLGETTYPEINFO      : 47,
    SQLPARAMDATA        : 48,
    SQLPUTDATA          : 49,
    SQLSETCONNECTOPTION : 50,
    SQLSETSTMTOPTION    : 51,
    SQLSPECIALCOLUMNS   : 52,
    SQLSTATISTICS       : 53,
    SQLTABLES           : 54,
    SQLBROWSECONNECT    : 55,
    SQLCOLUMNPRIVILEGES : 56,
    SQLDATASOURCES      : 57,
    SQLDESCRIBEPARAM    : 58,
    SQLEXTENDEDFETCH    : 59,
    SQLFOREIGNKEYS      : 60,
    SQLMORERESULTS      : 61,
    SQLNATIVESQL        : 62,
    SQLNUMPARAMS        : 63,
    SQLPARAMOPTIONS     : 64,
    SQLPRIMARYKEYS      : 65,
    SQLPROCEDURECOLUMNS : 66,
    SQLPROCEDURES       : 67,
    SQLSETPOS           : 68,
    SQLSETSCROLLOPTIONS : 69,
    SQLTABLEPRIVILEGES  : 70,
    SQLDRIVERS          : 71,
    SQLBINDPARAMETER    : 72,
    SQLALLOCHANDLESTD   : 73,
    SQLGETDATAINTERNAL  : 174,
    LOADBYORDINAL       : 199,
    ODBC3_ALL_FUNCTIONS : 999,
    SQLALLOCHANDLE      : 1001,
    SQLBINDPARAM        : 1002,
    SQLCLOSECURSOR      : 1003,
    SQLCOPYDESC         : 1004,
    SQLENDTRAN          : 1005,
    SQLFREEHANDLE       : 1006,
    SQLGETCONNECTATTR   : 1007,
    SQLGETDESCFIELD     : 1008,
    SQLGETDESCREC       : 1009,
    SQLGETDIAGFIELD     : 1010,
    SQLGETDIAGREC       : 1011,
    SQLGETENVATTR       : 1012,
    SQLSETCONNECTATTR   : 1016,
    SQLSETDESCFIELD     : 1017,
    SQLSETDESCREC       : 1019,
    SQLSETSTMTATTR      : 1020,
    SQLFETCHSCROLL      : 1021,
    SQLGETLENGTH        : 1022,
    SQLGETPOSITION      : 1023,
    SQLGETSUBSTRING     : 1024,
    SQLEXTENDEDPROCEDURES : 1025,
    SQLEXTENDEDPROCEDURECOLUMNS : 1026,
    SQLBINDFILETOCOL    : 1250,
    SQLBINDFILETOPARAM  : 1251,
    SQLSETCOLATTRIBUTES : 1252,
    SQLGETSQLCA         : 1253,
    SQLSETCONNECTION    : 1254,
    SQLGETDATALINKATTR  : 1255,
    SQLBUILDDATALINK    : 1256,
    SQLNEXTRESULT       : 1257,
    SQLCREATEDB         : 1258,
    SQLDROPDB           : 1259,
    SQLCREATEPKG        : 1260,
    SQLDROPPKG          : 1261,
    SQLEXTENDEDPREPARE  : 1296,
    SQLEXTENDEDBIND     : 1297,
    SQLEXTENDEDDESCRIBE : 1298,
    SQLRELOADCONFIG     : 1299
}

module.exports.functionids = {
    1     : "SQLAllocConnect",
    2     : "SQLAllocEnv",
    3     : "SQLAllocStmt",
    4     : "SQLBindCol",
    5     : "SQLCancel",
    6     : "SQLColAttribute",
    7     : "SQLConnect",
    8     : "SQLDescribeCol",
    9     : "SQLDisconnect",
    10    : "SQLError",
    11    : "SQLExecDirect",
    12    : "SQLExecute",
    13    : "SQLFetch",
    14    : "SQLFreeConnect",
    15    : "SQLFreeEnv",
    16    : "SQLFreeStmt",
    17    : "SQLFetCursorName",
    18    : "SQLNumResultCols",
    19    : "SQLPrepare",
    20    : "SQLRowCount",
    21    : "SQLSetCursorName",
    22    : "SQLSetParam",
    23    : "SQLTransact",
    24    : "SQLBulkOperations",
    40    : "SQLColumns",
    41    : "SQLDriverConnect",
    42    : "SQLGetConnectOptions",
    43    : "SQLGetData",
    44    : "SQLGetFunctions",
    45    : "SQLGetInfo",
    46    : "SQLGetStmtOption",
    47    : "SQLGetTypeInfo",
    48    : "SQLParamData",
    49    : "SQLPutData",
    50    : "SQLSetConnectOption",
    51    : "SQLSetStmtOption",
    52    : "SQLSpecialColumns",
    53    : "SQLStatistics",
    54    : "SQLTables",
    55    : "SQLBrowseConnect",
    56    : "SQLColumnPrivileges",
    57    : "SQLDataSources",
    58    : "SQLDescribeParam",
    59    : "SQLExtendedFetch",
    60    : "SQLForeignKeys",
    61    : "SQLMoreResults",
    62    : "SQLNativeSql",
    63    : "SQLNumParams",
    64    : "SQLParamOptions",
    65    : "SQLPrimaryKeys",
    66    : "SQLProcedureColumns",
    67    : "SQLProcedures",
    68    : "SQLSetPos",
    69    : "SQLSetScrollOptions",
    70    : "SQLTablePrivileges",
    71    : "SQLDrivers",
    72    : "SQLBindParameter",
    73    : "SQLAllocHandleStd",
    174   : "SQLGetDataInternal"
}
module.exports.funcId = {
    // Function Id for SQLGetFunctions i.e. ibmdb.getFunctions()
    // Defined in sqlcli1.h and sqlext.h
    ALLFUNCTIONS      : 0, //SQL_API_ALL_FUNCTIONS
    SQLALLOCCONNECT   : 1, //SQL_API_SQLALLOCCONNECT
    SQLALLOCENV       : 2, //SQL_API_SQLALLOCENV
    SQLALLOCSTMT      : 3, //SQL_API_SQLALLOCSTMT
    SQLBINDCOL        : 4, //SQL_API_SQLBINDCOL
    SQLCANCEL         : 5, //SQL_API_SQLCANCEL
    SQLCOLATTRIBUTE   : 6, //SQL_API_SQLCOLATTRIBUTE
    SQLCOLATTRIBUTES  : 6, //SQL_API_SQLCOLATTRIBUTES
    SQLCONNECT        : 7, //SQL_API_SQLCONNECT
    SQLDESCRIBECOL    : 8, //SQL_API_SQLDESCRIBECOL
    SQLDISCONNECT     : 9, //SQL_API_SQLDISCONNECT
    SQLERROR          : 10, //SQL_API_SQLERROR
    SQLEXECDIRECT     : 11, //SQL_API_SQLEXECDIRECT
    SQLEXECUTE        : 12, //SQL_API_SQLEXECUTE
    SQLFETCH          : 13, //SQL_API_SQLFETCH
    SQLFREECONNECT    : 14, //SQL_API_SQLFREECONNECT
    SQLFREEENV        : 15, //SQL_API_SQLFREEENV
    SQLFREESTMT       : 16, //SQL_API_SQLFREESTMT
    SQLGETCURSORNAME  : 17, //SQL_API_SQLGETCURSORNAME
    SQLNUMRESULTCOLS  : 18, //SQL_API_SQLNUMRESULTCOLS
    SQLPREPARE        : 19, //SQL_API_SQLPREPARE
    SQLROWCOUNT       : 20, //SQL_API_SQLROWCOUNT
    SQLSETCURSORNAME  : 21, //SQL_API_SQLSETCURSORNAME
    SQLSETPARAM       : 22, //SQL_API_SQLSETPARAM
    SQLTRANSACT       : 23, //SQL_API_SQLTRANSACT
    SQLBULKOPERATIONS : 24, //SQL_API_SQLBULKOPERATIONS
    SQLCOLUMNS        : 40, //SQL_API_SQLCOLUMNS
    SQLDRIVERCONNECT  : 41, //SQL_API_SQLDRIVERCONNECT
    SQLGETCONNECTOPTION : 42,
    SQLGETDATA          : 43,
    SQLGETFUNCTIONS     : 44,
    SQLGETINFO          : 45,
    SQLGETSTMTOPTION    : 46,
    SQLGETTYPEINFO      : 47,
    SQLPARAMDATA        : 48,
    SQLPUTDATA          : 49,
    SQLSETCONNECTOPTION : 50,
    SQLSETSTMTOPTION    : 51,
    SQLSPECIALCOLUMNS   : 52,
    SQLSTATISTICS       : 53,
    SQLTABLES           : 54,
    SQLBROWSECONNECT    : 55,
    SQLCOLUMNPRIVILEGES : 56,
    SQLDATASOURCES      : 57,
    SQLDESCRIBEPARAM    : 58,
    SQLEXTENDEDFETCH    : 59,
    SQLFOREIGNKEYS      : 60,
    SQLMORERESULTS      : 61,
    SQLNATIVESQL        : 62,
    SQLNUMPARAMS        : 63,
    SQLPARAMOPTIONS     : 64,
    SQLPRIMARYKEYS      : 65,
    SQLPROCEDURECOLUMNS : 66,
    SQLPROCEDURES       : 67,
    SQLSETPOS           : 68,
    SQLSETSCROLLOPTIONS : 69,
    SQLTABLEPRIVILEGES  : 70,
    SQLDRIVERS          : 71,
    SQLBINDPARAMETER    : 72,
    SQLALLOCHANDLESTD   : 73,
    SQLGETDATAINTERNAL  : 174,
    LOADBYORDINAL       : 199,
    ODBC3_ALL_FUNCTIONS : 999,
    SQLALLOCHANDLE      : 1001,
    SQLBINDPARAM        : 1002,
    SQLCLOSECURSOR      : 1003,
    SQLCOPYDESC         : 1004,
    SQLENDTRAN          : 1005,
    SQLFREEHANDLE       : 1006,
    SQLGETCONNECTATTR   : 1007,
    SQLGETDESCFIELD     : 1008,
    SQLGETDESCREC       : 1009,
    SQLGETDIAGFIELD     : 1010,
    SQLGETDIAGREC       : 1011,
    SQLGETENVATTR       : 1012,
    SQLSETCONNECTATTR   : 1016,
    SQLSETDESCFIELD     : 1017,
    SQLSETDESCREC       : 1019,
    SQLSETSTMTATTR      : 1020,
    SQLFETCHSCROLL      : 1021,
    SQLGETLENGTH        : 1022,
    SQLGETPOSITION      : 1023,
    SQLGETSUBSTRING     : 1024,
    SQLEXTENDEDPROCEDURES : 1025,
    SQLEXTENDEDPROCEDURECOLUMNS : 1026,
    SQLBINDFILETOCOL    : 1250,
    SQLBINDFILETOPARAM  : 1251,
    SQLSETCOLATTRIBUTES : 1252,
    SQLGETSQLCA         : 1253,
    SQLSETCONNECTION    : 1254,
    SQLGETDATALINKATTR  : 1255,
    SQLBUILDDATALINK    : 1256,
    SQLNEXTRESULT       : 1257,
    SQLCREATEDB         : 1258,
    SQLDROPDB           : 1259,
    SQLCREATEPKG        : 1260,
    SQLDROPPKG          : 1261,
    SQLEXTENDEDPREPARE  : 1296,
    SQLEXTENDEDBIND     : 1297,
    SQLEXTENDEDDESCRIBE : 1298,
    SQLRELOADCONFIG     : 1299
}

module.exports.connAttributes = {
    SQL_ATTR_ACCESS_MODE : 101,
    SQL_ATTR_AUTOCOMMIT : 102,
    SQL_ATTR_LOGIN_TIMEOUT : 103,
    SQL_ATTR_TRACE : 104,
    SQL_ATTR_TRACEFILE : 105,
    SQL_ATTR_TRANSLATE_LIB : 106,
    SQL_ATTR_TRANSLATE_OPTION : 107,
    SQL_ATTR_TXN_ISOLATION : 108,
    SQL_ATTR_CURRENT_CATALOG : 109,
    SQL_ATTR_ODBC_CURSORS : 110,
    SQL_ATTR_QUIET_MODE : 111,
    SQL_ATTR_PACKET_SIZE :112,
    SQL_ATTR_CONNECTION_TIMEOUT : 113,
    SQL_ATTR_DISCONNECT_BEHAVIOR : 114,
    SQL_ATTR_ANSI_APP : 115,
    SQL_ATTR_RESET_CONNECTION : 116,
    SQL_ATTR_ASYNC_DBC_FUNCTIONS_ENABLE : 117,
    SQL_ATTR_INFO_USERID : 1281,
    SQL_ATTR_INFO_WRKSTNNAME : 1282,
    SQL_ATTR_INFO_APPLNAME : 1283,
    SQL_ATTR_INFO_ACCTSTR : 1284,
    SQL_ATTR_ALLOW_INTERLEAVED_GETDATA : 2599
}

