var common = require("./common")
	, odbc = require("../")
	, db = new odbc.Database()
	, fs = require("fs");

db.open(common.connectionString, function(err)
{
	if (err) {
		console.error(err.message);
		return;
	}
	let app = function (req, res) {
		if (req.url == "/close") {
			db.closeSync();
			db = null;
            res.writeHead(200, {'Content-Type': 'text/plain'});
            res.write("Web Application Ended.");
			res.end();
			process.exit(1);
		}

		var query = "select 1234 from sysibm.sysdummy1";

		db && db.query(query, function(err, rows)
		{
			if (err) {
				console.error(err.message);
			}
			console.log("Selected Data = ", rows);
            res.writeHead(200, {'Content-Type': 'text/plain'});
            res.write(JSON.stringify(rows));
			res.end();
		});
	}

	// Create options object of key and certificate for SSL connection.
	// These key and cert files are generated by below command 
	// executed from "git bash" terminal on Windows:
	// openssl req -nodes -new -x509 -keyout server.key -out server.cert
	const options = {
		key: fs.readFileSync("server.key"),
		cert: fs.readFileSync("server.cert")
	};
    require('https').createServer(options, app).listen(8082, "127.0.0.1");
	console.log("App is listening on 127.0.0.1:8082");
});

process.on('uncaughtException', function (err) {
	console.error('uncaughtException:' + err);
	console.error(err.stack);
});
